/****************************************************************************
 *	ggxsnd: g^2xsnd is not gxsnd
 *		
 *			g:   tolower(*("High"))-1 (Means. Not High)
 *			g:   Grade
 *			x:   X Window System
 *			snd: SouND tool
 *
 *			Date. 1994/07/20 -- 1995/07/07
 *			Date. 1998/05/14 -- 1998/05/15 (Debian GNU/Linux support.)
 *				Programed by Nobuyuki Maruichi
 *				Adviced by S.Kouno
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 *	from
 *		mixcd.c(mwxcd.c)
 *		PCM player T-E-S-T program  Copyright (C) 1993 S.Kouno
 *		PCM recording T-E-S-T program  Copyright (C) 1993 S.Kouno
 ***************************************************************************/

/***********************************
 *	Ūʥ󥯥롼ɡե
 ***********************************/
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>

/***************************************************
 *	X11/X Toolkit δŪʥ󥯥롼ɡե
 ***************************************************/
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Core.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>
#include <X11/Xmu/Atoms.h>
#include <X11/Xlocale.h>

/*****************************************
 * Atena Widget Υ󥯥롼ɡե
 *****************************************/
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include "WaveChart.h"

/*******************************
 *	ѤΥإåե
 *******************************/
#include <fcntl.h>
#include "snd.h"
#include "ggxsnd.h"

/*******************************
 *	ѥܥΥӥåȥޥå
 *******************************/
#include <X11/bitmaps/xlogo11>
#include "bitmaps/rec.xbm"	
#include "bitmaps/rew.xbm"		/* |: Υȥåذư */
#include "bitmaps/ff.xbm"		/* |: ĸΥȥåذư */
#include "bitmaps/play.xbm"		/*  | : ܥ */
#include "bitmaps/stop.xbm"		/*    : ߥܥ */
#include "bitmaps/pause.xbm"	/*  ||  : ߥܥ */
#include "bitmaps/vup.xbm"		/*  | : ܥ塼ࡦåסܥ */
#include "bitmaps/vdown.xbm"	/* |  : ܥ塼ࡦ󡦥ܥ */

/***************************************************************************
 *	Хѿ
 *		ץ󥰥ط
 *			MinuteSize: 	ʬ֤ΥХȿ
 *			SecondSize: 	ô֤ΥХȿ
 *			CentiSecSize: 	ô֤ΥХȿ
 *			currentSize: 	˳ȤȷΥХȿ
 *			unitSize: 		γñ
 *			deltaSize: 		Ͽ֤ѹñ
 *			recTimeResizeCounter: 	Ͽ֤ѹѤΥ
 *		ȷط
 *			memoryListTop:	ꡦꥹȤƬ
 ***************************************************************************/
long MinuteSize = SND_RATE * 60;
long SecondSize = SND_RATE;
long CentiSecSize = SND_RATE / 100;
long currentSize = 10 * SND_RATE;
long unitSize = SND_RATE / 10;
long deltaSize = SND_RATE / 100;
int recTimeResizeCounter;
WavesLink *memoryListTop = NULL;
Atom WaveAtom;
Widget topLevel;
Widget pcmArea, pcmMenuArea, pcmMenu, pcmMainArea;
Widget pcmInfo, pcmTitle, pcmZoom, pcmEdit, pcmView, pcmWave;
Widget memoryList;
Widget fileMenuButton;
Widget memoryPlayBlock, memoryControlBlock;
Widget clearMemory, newMemory, editMemory, deleteMemory;
Widget timeControlBlock, decrmentTime, recordingTime;
Widget endBlock, incrementTime, endTime;
Widget memoryView;
Pixmap recPixmap, rewPixmap, ffPixmap, playPixmap;
Pixmap stopPixmap, pausePixmap, timeDecPixmap, timeIncPixmap, mark;

char ggxsndTitle[256];

const char *pcmIoName[3] = {
	"TOWNS/8bits-PCM",
	"TOWNS/16bits-PCM",
	"Unknown"
};

struct menu_data topMenuInfo[] = {
	{TypeSmeLine, "fileMenuTopLine", NULL, NULL},
	{TypeSmeBSB,  "fileLoad", NULL, load_chd}, 
	{TypeSmeBSB,  "fileSave", NULL, save_chd},
	{TypeSmeLine, "fileMenuLine", NULL, NULL},
	{TypeSmeBSB,  "fileQuit", NULL, quit},
	{EOF, NULL, NULL, NULL}
};

struct menuData fileMenus = {
	NULL,
	NULL,
	"fileMenu", 
	sizeof(topMenuInfo) / sizeof(topMenuInfo[0]) - 1,
	preFileMenu, 
	NULL, 
	topMenuInfo
};

static struct menu_data copyMenuInfo[] = {
	{TypeSmeLine, "copyMenuTopLine", NULL, NULL},
	{TypeSmeBSB,       "copyCut", NULL, waveCutCall},
	{TypeSmeBSB,      "copyCopy", NULL, waveCopyCall},
	{TypeSmeBSB,     "copyPaste", NULL, wavePasteCall},
	{TypeSmeLine, "copyMenuLine1", NULL, NULL},
	{TypeSmeBSB,     "copyClear", NULL, waveClearCall},
	{TypeSmeBSB,  "copyUnselect", NULL, waveUnselectCall},
	{TypeSmeLine, "copyMenuLine2", NULL, NULL},
	{TypeSmeBSB,  "selectZoom", NULL, NULL},
	{EOF, NULL, NULL, NULL}
};

struct menuData copyMenus = {
	NULL,
	NULL,
	"copyMenu", 
	sizeof(copyMenuInfo) / sizeof(copyMenuInfo[0]) - 1,
	preSelectionMenu, 
	NULL, 
	copyMenuInfo
};

AppData app_data;

/***************************************************************************
 --------------------------------------------------------------------------
	ץꥱ󡦥꥽
 --------------------------------------------------------------------------
 Name               Class              RepType         Default Value
 ----               -----              -------         -------------
 recordingCmd       RecordingCmd       String          "/bin/cat /dev/pcmrec"
 playingCmd         PlayingCmd         String          "/bin/cat -u > /dev/pcm"
 recordingDev       RecordingDev       String          NULL
 playingDev         PlayingDev         String          NULL
 recordingPcmIo     RecordingPcmIo     XggRPcmIoType   pcm8towns
 playingPcmIo       PlayingPcmIo       XggRPcmIoType   pcm8towns
 --------------------------------------------------------------------------

 ***************************************************************************/
/* resource list */
static XtResource resources[] = {
	{
		XtNrecordingCmd,
		XtCRecordingCmd,
		XtRString,
		sizeof(XtPointer),
		XtOffsetOf(AppData, recordingCmd),
		XtRImmediate,
		(XtPointer) "/bin/cat /dev/pcmrec",
	},
	{
		XtNplayingCmd,
		XtCPlayingCmd,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, playingCmd),
		XtRImmediate,
		(XtPointer) "/bin/cat -u > /dev/pcm",
	},
	{
		XtNrecordingDev,
		XtCRecordingDev,
		XtRString,
		sizeof(XtPointer),
		XtOffsetOf(AppData, recordingDev),
		XtRImmediate,
		(XtPointer) NULL,
	},
	{
		XtNplayingDev,
		XtCPlayingDev,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, playingDev),
		XtRImmediate,
		(XtPointer) NULL,
	},
	{
		XtNrecordingPcmIo,
		XtCRecordingPcmIo,
		XggRPcmIoType,
		sizeof(ioType),
		XtOffsetOf(AppData, recordingPcmIo),
		XtRImmediate,
		(XtPointer) pcm8towns,
	},
	{
		XtNplayingPcmIo,
		XtCPlayingPcmIo,
		XggRPcmIoType,
		sizeof(ioType),
		XtOffsetOf(AppData, playingPcmIo),
		XtRImmediate,
		(XtPointer) pcm8towns,
	},
};

/* Command-line options table */
static XrmOptionDescRec options[] = {
	{"-recdev", 		"*recordingDev", 		XrmoptionSepArg, NULL},
	{"-playdev", 		"*playingDev", 			XrmoptionSepArg, NULL},
	{"-recio", 			"*recordingPcmIo", 		XrmoptionSepArg, NULL},
	{"-playio", 		"*playingPcmIo", 		XrmoptionSepArg, NULL},
};

/***************************************************************************
 *	ExtVaSetSensitives: ʣΥåȤδꤹ
 *	
 *		void ExtVaSetSensitives(Boolean sensitive, ...);
 *	
 *		Boolean sensitive;
 *		
 *		Widget target1; 
 *		...             
 *		
 *		NULL;
 *	
 *		
 ***************************************************************************/
void ExtVaSetSensitives(Boolean sensitive, ...)
{
	va_list ap;
	Widget target = NULL;

	va_start(ap, sensitive);
	while((target = va_arg(ap, Widget)) != NULL) {
		XtSetSensitive(target, sensitive);
	}
	va_end(ap);
}

/***************************************************************************
 *	quit: ggxsnd λ
 *	
 *		void quit(void);
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void quit(Widget w, XtPointer client_data, XtPointer call_data)
{
	operationEnd();
	exit(0);
}

/***************************************************************************
 *	WaveListIndex: 󥯤줿ȷꥹȤꤵ줿ȷ
 *	
 *		WavesLink *WaveListIndex(int index);
 *	
 *		int index;		󥯤Ƭν֡ʤޤϡţϣơ
 *	֤
 *		NULL	ꤵ줿֤ȷ¸ߤʤ
 *		NULL	ꤵ줿֤ȷţϣƤʤ󥯤
 *	
 *	
 ***************************************************************************/
WavesLink *WaveListIndex(int index)
{
	int counter = 0;
	WavesLink *waveOrder = NULL;

	for(waveOrder = memoryListTop, counter = 0;waveOrder != NULL && 
		((index == EOF)?(waveOrder->next_ptr != NULL):(counter < index));
				++counter, waveOrder = waveOrder->next_ptr)
		;		/* Υ롼 */
	
	return(waveOrder);
}

/***************************************************************************
 *	makeMemoryList: ꡼ꥹѤʸ򤵤ݥ
 *	
 *		String *makeMemoryList(WavesLink *waveOrder, int *numOfList);
 *	
 *		const WavesLink *waveOrder;	ȷꥹ
 *		int *numOfList;				ȷꥹȤο֤
 *	֤
 *		NULL		꡼­
 *		NULLʳ	ʸ򤵤ݥ
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void makeMemoryList(void)
{
	int numOfList;
	int currentPane;
	static char *empty = "Empty";
	String *memory_list_ptr;
	extern WavesLink *currentWaves;

	memory_list_ptr = getMemoryList(memoryListTop, &numOfList);
	if(numOfList > 0) {
#ifdef	DEBUG
		int counter;

		for(counter = 0;counter < numOfList;++counter) {
			printf("makeMemoryList #%d:\"\%s\"\n", counter, *(memory_list_ptr + counter));
		}
#endif	/*DEBUG*/
		XawListChange(memoryList, memory_list_ptr, numOfList, 0, True);
		XtSetSensitive(memoryList, True);
		currentPane = NumberOfPanes(currentWaves);
		if(currentPane >= 0) {
			XawListHighlight(memoryList, currentPane);
		}
	} else {
		XawListChange(memoryList, &empty, 1, 0, True);
		XtSetSensitive(memoryList, False);
	}
}

/***************************************************************************
 *	DeleteMemory: ꡼ꥹѤʸ򤵤ݥ
 *	
 *		void DeleteMemory(void);
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void DeleteMemory(Widget w, XtPointer client_data, XtPointer call_data)
{
	WavesLink *release_wave;
	extern WavesLink *currentWaves;
	
	release_wave = WaveListShowCurrent(EOF);
	if(release_wave == currentWaves) {
		currentWaves = NULL;
		XawWaveAllClear(pcmWave);
	}
	if(release_wave != NULL) {
		if(release_wave->prev_ptr == NULL) {
			/* 󥯤Ƭ */
			memoryListTop = release_wave->next_ptr;
		}
		UnlinkWaves(release_wave);
		FreeWaves(release_wave);
		release_wave = NULL;
	}
	makeMemoryList();
	SetCurrentWaveName(currentWaves);
}

/***************************************************************************
 *	UnselecteMemory: ꡼ꥹѤʸ򤵤ݥ
 *	
 *		void DeleteMemory(void);
 *	
 *	
 ***************************************************************************/
/*ARGSUSED*/
void UnselecteMemory(Widget w, XtPointer client_data, XtPointer call_data)
{
	extern WavesLink *currentWaves;
	
	currentWaves = NULL;
	SetCurrentWaveName(currentWaves);
	XawWaveAllClear(pcmWave);
	XawListUnhighlight(memoryList);
}

/***************************************************************************
 *	WaveListShowCurrent: ꡼ꥹȤΥꥹȤ
 *	
 *		WavesLink *WaveListShowCurrent(int def_index);
 *	
 *		int def_index;		֤ΥꥹȤʤȤν
 *				ʾ:	ꥹȤ def_index - 1 ܤ֤Ƭϡܡ
 *				: 	NULL֤
 *				EOF: 	ꥹȤ֤
 *	֤
 *		NULL		ꥹȤιܤ򤵤ƤʤǥեȤιܤ
 *		NULLʳ	Υꥹ
 *	
 *		꡼ꥹȤΥꥹȤ롣򤵤ƤʤȤϡ
 *		 def_index ˤä֤ͤۤʤ롣
 ***************************************************************************/
WavesLink *WaveListShowCurrent(int def_index)
{
	WavesLink *waveOrder = NULL;
	XawListReturnStruct *wave_point;

	wave_point = XawListShowCurrent(memoryList);
	if(wave_point->list_index != XAW_LIST_NONE)
		waveOrder = WaveListIndex(wave_point->list_index);
	else
		switch(def_index) {
		case EOF:
			waveOrder = WaveListIndex(def_index);
			break;
		case 0:
			break;
		default:
			waveOrder = WaveListIndex(def_index - 1);
			break;
		}
	return(waveOrder);
}

/***************************************************************************
 *	SetRecordingTime: 쥳ǥ󥰡
 *	
 *		void SetRecordingTime(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void SetRecordingTime(Widget w, long size)
{
	static char timeString[30];

	if(recTimeResizeCounter >= 0) {
		++recTimeResizeCounter;
		if(recTimeResizeCounter == 20) {
			deltaSize *= 10;
		}
		if(recTimeResizeCounter == 200) {
			recTimeResizeCounter = -1;
			deltaSize *= 10;
		}
	}
	sprintf(timeString, "%d:%02d.%02d", size / MinuteSize, 
			(size / SecondSize) % 60, (size / CentiSecSize) % 100);
	XtVaSetValues(w, XtNlabel, timeString, NULL);
}

/***************************************************************************
 *	IncrementTime: 쥳ǥ󥰡
 *	
 *		void IncrementTime(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void IncrementTime(Widget w, XtPointer client_data, XtPointer call_data)
{
	currentSize += deltaSize;
	SetRecordingTime((Widget)client_data, currentSize);
}

/***************************************************************************
 *	DecrmentTime: 쥳ǥ󥰡
 *	
 *		void DecrmentTime(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void DecrmentTime(Widget w, XtPointer client_data, XtPointer call_data)
{
	if(currentSize - deltaSize > 0) {
		currentSize -= deltaSize;
	}
	SetRecordingTime((Widget)client_data, currentSize);
}

/***************************************************************************
 *	initTimeChange: 쥳ǥ󥰡
 *	
 *		void initTimeChange(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void initTimeChange(Widget w, XtPointer client_data, XtPointer call_data)
{
	recTimeResizeCounter = 0;
	deltaSize = CentiSecSize;
}

/***************************************************************************
 *	WaveSelect: ȷ
 *	
 *		void WaveSelect(Widget w, 
 *						XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 ***************************************************************************/
void WaveSelect(Widget w, XtPointer client_data, XtPointer call_data)
{
	WavesLink *waveSelect = NULL;
	extern Widget pcmWave;

	XawWaveSelectionInit(pcmWave);
	waveSelect = WaveListShowCurrent(0);
	if(waveSelect != NULL) {
		WaveGraph(waveSelect);
	}
}

/***************************************************************************
 *	LabelPixmaps: 
 *	
 *		void LabelPixmaps(void);
 ***************************************************************************/
void LabelPixmaps(Display *display, Drawable drawable)
{
    mark = XCreateBitmapFromData(display, drawable,
						xlogo11_bits, xlogo11_width, xlogo11_height);

	recPixmap = XCreateBitmapFromData(display, drawable, 
						rec_bits, rec_width, rec_height);

	rewPixmap = XCreateBitmapFromData(display, drawable, 
						rew_bits, rew_width, rew_height);

	playPixmap = XCreateBitmapFromData(display, drawable, 
						play_bits, play_width, play_height);

	ffPixmap = XCreateBitmapFromData(display, 
						drawable, ff_bits, ff_width, ff_height);

	stopPixmap = XCreateBitmapFromData(display, 
						drawable, stop_bits, stop_width, stop_height);

	pausePixmap = XCreateBitmapFromData(display, 
						drawable, pause_bits, pause_width, pause_height);

	timeDecPixmap = XCreateBitmapFromData(display, 
						drawable, vdown_bits, vdown_width, vdown_height);

	timeIncPixmap = XCreateBitmapFromData(display, 
						drawable, vup_bits, vup_width, vup_height);
}

/***************************************************************************
 *	memory_block_init: 쥳ǥ󥰡
 *	
 *		void memory_block_init(Widget parent); 
 *	
 *		Widget parent;
 ***************************************************************************/
void memory_block_init(Widget parent)
{
	memoryPlayBlock = XtVaCreateManagedWidget(
			"memoryPlayBlock", 				/* widget name   */
			panedWidgetClass, 				/* widget class */
			parent, 						/* parent widget */
			NULL 							/* argument list */
			);

	memoryControlBlock = XtVaCreateManagedWidget(
			"memoryControlBlock", 			/* widget name   */
			panedWidgetClass,	 			/* widget class */
			memoryPlayBlock, 				/* parent widget */
			XtNorientation, XtorientHorizontal,
			NULL 							/* argument list */
			);
	
	clearMemory = XtVaCreateManagedWidget(
			"clearMemory", 					/* widget name   */
			commandWidgetClass,			 	/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	newMemory = XtVaCreateManagedWidget(
			"newMemory", 					/* widget name   */
			commandWidgetClass, 			/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	deleteMemory = XtVaCreateManagedWidget(
			"deleteMemory", 				/* widget name   */
			commandWidgetClass,			 	/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	editMemory = XtVaCreateManagedWidget(
			"editMemory", 					/* widget name   */
			toggleWidgetClass, 				/* widget class */
			memoryControlBlock, 			/* parent widget */
			NULL 							/* argument list */
			);
	
	timeControlBlock = XtVaCreateManagedWidget(
			"timeControlBlock", 				/* widget name   */
			panedWidgetClass, 				/* widget class */
			memoryPlayBlock, 				/* parent widget*/
			XtNorientation, XtorientHorizontal,
			NULL 							/* argument list*/
			);

	recordingTime = XtVaCreateManagedWidget(
			"recordingTime", 				/* widget name   */
			commandWidgetClass, 			/* widget class */
			timeControlBlock, 				/* parent widget */
			NULL 							/* argument list */
			);
	
	decrmentTime = XtVaCreateManagedWidget(
			"decrmentTime", 				/* widget name   */
			repeaterWidgetClass, 			/* widget class */
			timeControlBlock, 				/* parent widget */
			XtNbitmap, timeDecPixmap,
			NULL 							/* argument list */
			);
	
	incrementTime = XtVaCreateManagedWidget(
			"incrementTime", 				/* widget name   */
			repeaterWidgetClass, 			/* widget class */
			timeControlBlock, 				/* parent widget */
			XtNbitmap, timeIncPixmap,
			NULL 							/* argument list*/
			);

	memoryView = XtVaCreateManagedWidget(
			"memoryView", 					/* widget name   */
			viewportWidgetClass, 			/* widget class */
			memoryPlayBlock, 				/* parent widget */
			XtNallowVert, TRUE, 			/*  */
			NULL 							/* argument list */
			);
	
	memoryList = XtVaCreateManagedWidget(
			"memoryList", 					/* widget name   */
			listWidgetClass, 				/* widget class */
			memoryView, 					/* parent widget */
			NULL 							/* argument list */
			);
	XtAddCallback(memoryList, XtNcallback, WaveSelect, 0);
	SetRecordingTime(recordingTime, currentSize);
	XtAddCallback(deleteMemory, XtNcallback, DeleteMemory, 0);
	XtAddCallback(newMemory, XtNcallback, UnselecteMemory, 0);
	XtAddCallback(incrementTime, XtNcallback, IncrementTime, recordingTime);
	XtAddCallback(decrmentTime, XtNcallback, DecrmentTime, recordingTime);
	XtAddCallback(incrementTime, XtNstartCallback, initTimeChange, 0);
	XtAddCallback(decrmentTime, XtNstartCallback, initTimeChange, 0);
	makeMemoryList();
}

/***************************************************************************
 *	MenuSelect: ˥塼
 *	
 *		static void MenuSelect(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
static void MenuSelect(Widget w, XtPointer client_data, XtPointer garbage)
{
	struct menu_data *info = (struct menu_data*) client_data;

	/* printf("Menu item %s has been selected.\n", XtName(w)); */
	if (info->function != NULL) {
		info->function(w, client_data, NULL);
	}
}

/***************************************************************************
 *	makeMenus: ˥塼
 *	
 *		void makeMenus(Widget parent, struct menuData *menuInfo);
 *	
 *		Widget parent;		ƥå
 *		struct menuData *menuInfo;
 *	
 *		
 ***************************************************************************/
void makeMenus(Widget parent, struct menuData *menuInfo)
{
	int i;
	int numOfMenuItems;
	char name_buffer[20];
	Widget entry = NULL;

	numOfMenuItems = menuInfo->num;
	/* printf("Menu Items = %d.\n", numOfMenuItems); */

	sprintf(name_buffer, "%sButton", menuInfo->menuName);
	menuInfo->menuButton = XtVaCreateManagedWidget(
						name_buffer, 
						menuButtonWidgetClass, 
						parent,
						XtNmenuName, menuInfo->menuName, 
						NULL);
	menuInfo->menu = 
			XtCreatePopupShell(menuInfo->menuName, 
					simpleMenuWidgetClass, menuInfo->menuButton, NULL, 0);
	if(menuInfo->popup != NULL) {
		XtAddCallback(menuInfo->menu, XtNpopupCallback, 
							menuInfo->popup, (XtPointer)menuInfo);
	}
	if(menuInfo->popdown != NULL) {
		XtAddCallback(menuInfo->menu, XtNpopdownCallback, 
							menuInfo->popdown, (XtPointer)menuInfo);
	}

	for (i = 0; i < numOfMenuItems; i++) {
		switch(menuInfo->info[i].type) {
		case TypeSme:
			entry = XtCreateManagedWidget(menuInfo->info[i].widgetName, 
							smeObjectClass, menuInfo->menu, NULL, 0);
			break;
		case TypeSmeLine:
			entry = XtCreateManagedWidget(menuInfo->info[i].widgetName,
							smeLineObjectClass, menuInfo->menu, NULL, 0);
			break;
		case TypeSmeBSB:
			entry = XtCreateManagedWidget(menuInfo->info[i].widgetName, 
							smeBSBObjectClass, menuInfo->menu, NULL, 0);
			XtAddCallback(entry, XtNcallback, 
							MenuSelect, (XtPointer)&menuInfo->info[i]);
			break;
		default:
			break;
		}
		menuInfo->info[i].myWidget = entry;
	}
}

/***************************************************************************
 *	main: 
 *	
 *		int main(int argc, char **argv);
 *	
 *		int argc;		
 *		char **argv;	
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int main(int argc, char **argv)
{
	XtAppContext app_context;
	extern WavesLink *currentWaves;
	static XtActionsRec selectionActions[] = {
		{"actionCall", OnceActionCall},
	};

	XtSetLanguageProc(NULL, NULL, NULL);

	topLevel = XtVaAppInitialize(
		&app_context, 				/* Application context */
		"Ggxsnd", 					/* Application class */
		options, XtNumber(options), /* command line */
		&argc, argv,				/* command line args */
		NULL, 						/* for missing app-defaults file */
		NULL);						/* terminate varargs list */

	/* PCM  I/O פʸ󤫤Ѵ륳СϿ */
	XtAppSetTypeConverter(app_context, XtRString, 
				XggRPcmIoType, XggTypeConverter, NULL, 0, XtCacheNone, NULL);

	XtGetApplicationResources(topLevel, 
		&app_data, 
		resources, 
		XtNumber(resources), 
		NULL, 
		0);

	LabelPixmaps(XtDisplay(topLevel), RootWindowOfScreen(XtScreen(topLevel)));

	pcmArea = XtVaCreateManagedWidget(
		"pcmArea", 				/* arbitrary widget name */
		panedWidgetClass,		/* widget class from Form.h */
		topLevel,	 			/* parent widget */
		NULL);					/* tarminate varargs list */

	pcmMenuArea = XtVaCreateManagedWidget(
		"pcmMenuArea", 			/* arbitrary widget name */
		boxWidgetClass,			/* widget class from Form.h */
		pcmArea,	 			/* parent widget */
		NULL);					/* tarminate varargs list */

	XtAppAddActions(app_context, 
						selectionActions, XtNumber(selectionActions));
	makeMenus(pcmMenuArea, &fileMenus);
	loadDialogInit(fileMenus.menu, topMenuInfo[1].myWidget);
	saveDialogInit(fileMenus.menu, topMenuInfo[2].myWidget);
	makeMenus(pcmMenuArea, &copyMenus);

	pcmMainArea = XtVaCreateManagedWidget(
		"pcmMainArea", 			/* arbitrary widget name */
		panedWidgetClass,		/* widget class from Form.h */
		pcmArea,	 			/* parent widget */
		NULL);					/* tarminate varargs list */

	pcmEdit = XtVaCreateManagedWidget(
		"pcmEdit", 				/* arbitrary widget name */
		panedWidgetClass,		/* widget class from Form.h */
		pcmMainArea,			/* parent widget */
		NULL);					/* tarminate varargs list */

	pcmInfo = XtVaCreateManagedWidget(
		"pcmInfo", 				/* arbitrary widget name */
		panedWidgetClass,		/* widget class from Form.h */
		pcmEdit,				/* parent widget */
		NULL);					/* tarminate varargs list */

	pcmTitle = XtVaCreateManagedWidget(
		"pcmTitle", 			/* arbitrary widget name */
		labelWidgetClass,		/* widget class from Form.h */
		pcmInfo,				/* parent widget */
		NULL);					/* tarminate varargs list */

	pcmView = XtVaCreateManagedWidget(
			"pcmView", 				/* widget name   */
			viewportWidgetClass, 	/* widget class */
			pcmEdit, 				/* parent widget */
			XtNallowHoriz, TRUE, 	/*  */
			NULL 					/* argument list */
			);

	pcmWave = XtVaCreateManagedWidget(
		"pcmWave", 				/* arbitrary widget name */
		waveChartWidgetClass, 	/* widget class */
		pcmView,				/* parent widget */
		NULL);					/* tarminate varargs list */

	SetCurrentWaveName(currentWaves);
	XtAddCallback(pcmWave, XtNcallback, graphRedraw, (XtPointer) NULL);
	XtAddCallback(pcmWave, XtNselectConvert, WaveConvert, (XtPointer) NULL);
	XtAddCallback(pcmWave, XtNselectPaste, WavePaste, (XtPointer) NULL);
	XtAddCallback(pcmWave, XtNselectCut, WaveCut, (XtPointer) NULL);
	WaveAtom = XInternAtom(XtDisplay(topLevel), WAVE_PROPERTY_NAME, FALSE);
#ifdef	NEW_IMPLEMENT
#endif	/*NEW_IMPLEMENT*/
	sprintf(ggxsndTitle, "ggxsnd "GGXSND_VERSION" --[%s]", setlocale(LC_CTYPE, NULL));
	XtVaSetValues(topLevel, XtNtitle, ggxsndTitle, NULL);

	rec_panel_init(app_context, pcmEdit);
	memory_block_init(pcmMainArea);

	XtRealizeWidget(topLevel);

	XtAppMainLoop(app_context);
	return(0);
}

