/***************************************************************************
 *	stringuty.h: ʸ/ñ̽ؿ
 *	
 *			Date. 1996/05/16(Collected) -- 1996/05/18(First Fix)
 *				Programed by Nobuyuki Maruichi
 *	
 ***************************************************************************/
#ifndef	LINE_LINK_H
#define	LINE_LINK_H

/***************************************************************************
 *	øɸΥ󥯥롼ɥե
 ***************************************************************************/
#include <stdio.h>

#ifndef	NO_X_TOOLKIT
/***************************************************************************
 *	X Toolkit ɸ।󥯥롼ɥե
 ***************************************************************************/
# include <X11/Intrinsic.h>
# include <X11/StringDefs.h>
#endif	/*NO_X_TOOLKIT*/

#define NumberOfArray(array) (sizeof(array)/sizeof(array[0]))

/***************************************************************************
 *	LineLink: 󥰥롦󥯥ȡꥹȷʻȹ¤
 *	С
 *		char *string;					ʸ
 *		struct _LineLink *next_ptr;		ؤΥ
 *	
 *		󥯡ݥ󥿤ϡNULL ΤȤü򼨤
 *	
 *	Cd_Order: ֥롦󥯥ȡꥹȷʻȹ¤Τι¤
 *		
 *	ʸƬ
 *	
 *	ʸ󡡡
 *	
 *	ؤΥ󥯨ʸ󡡡ʸ
 *	
 *	ؤΥ󥯨ʸ󡡡
 *	
 *	ؤΥ󥯨
 *	
 *	NULLݥ
 *	
 ***************************************************************************/
typedef struct _LineLink {
	char *string;					/* ʸ */
	struct _LineLink *next_ptr;		/* ؤΥ */
} LineLink;

/***************************************************************************
 *	PointorsLinkǡѡѥݥ󥿤Υ󥯥ꥹȷ
 *	С
 *		void *data_ptr;
 *		const char *type_pointer;		NULL ξϡХåեʤݥ
 *		size_t bufferSize;				Хåեξ˻ѡʤ 0
 *		struct _PointorsLink *prevLink;
 *		struct _PointorsLink *nextLink;
 *		char typeName[1];				̾ʺξ1Хȡ
 *
 *	ǡ¤
 *		ǡ¤ΤƬ
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨 NULL 
 *		
 *		ؤΥ󥯨
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨
 *		
 *		ؤΥ󥯨
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨
 *		
 *		ؤΥ󥯨
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 *		
 *		
 *		ǡ¤Τ
 *		 NULL or 
 *		ǡΤب
 *		ǡ
 *		 ̾ؤ  NULL 
 *		
 *		 ХåեĹ 
 *		
 *		ؤΥ󥯨
 *		
 *		ؤΥ󥯨 NULL 
 *		
 *		̾Хåե
 *		
 *		Хåե
 *		
 *		
 *		
 *		  ݥ󥿤ͤ NULL ³褬Ѥ뤳Ȥ򼨤
 *		
 ***************************************************************************/
typedef struct _PointorsLink {
	void *data_ptr;					/* ݥ */
	const char *type_pointer;		/* NULL ξϡХåեʤݥ */
	size_t bufferSize;				/* Хåեξ˻ѡʤ 0 */
	struct _PointorsLink *prevLink;	/* ؤΥ */
	struct _PointorsLink *nextLink;	/* ؤΥ */
	char typeName[1];				/* ̾ʺξ1Хȡ */
} PointorsLink;

/***************************************************************************
 *	ץȥ
 ***************************************************************************/
int asciiStringCaseCmp(const char *s1, const char *s2);
LineLink *lineAlloc(const char *string);
void lineFree(LineLink *release_ptr);
void linesRelease(LineLink *lines);
LineLink *string2lines(const char *string);
LineLink *linesConnect(LineLink *lines1, LineLink *lines2);
int linesLength(LineLink *lines);
String lines2string(LineLink *lines);
LineLink *file2lines(FILE *stream);
int arrayCount(XtPointer *pointerArray);
void nullTerminatedPointerArrayFree(void **pointerArray);
int searchInStringArray(const char *target, int limit, const char **names, 
							int (*compare)(const char *s1, const char *s2));
int searchInStringPointerArray(const char *target, const char **names,
							int (*compare)(const char *s1, const char *s2));
int VaCreatePointorsLink(PointorsLink **linkBuffer, ...);
int VaAddValuesLink(PointorsLink **linkTop, ...);
int VaGetPointorsLink(const PointorsLink *linkBuffer, ...);
void VaDestroyPointorsLink(PointorsLink *linkBuffer);
void *cutoffPointorsLink(PointorsLink **linkBuffer);
const void *prevPointersLink(const void *pointer);
const void *nextPointersLink(const void *pointer);
const void *numSearch(const void *client_data, 
					int no, const void *(*nextStep)(const void *pointer));
int terminalCount(const void *client_data, 
							const void *(*nextStep)(const void *pointer));
int VaGetAbsValuesLink(const PointorsLink *linkBuffer, int step, ...);
int VaGetRelValuesLink(const PointorsLink *linkBuffer, int step, ...);

#endif	/*LINE_LINK_H*/

